<?php

namespace App\Http\Controllers;

use App\Models\AddToCart;
use App\Models\Product;
use Illuminate\Http\Request;
use Validator;
use DB;
class AddToCartController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function viewCart()
    {
        // try {
            // $data = AddToCart::with('product')->where('user_id', auth()->user()->id)->orderBy('created_at', 'DESC')->get();
            $data = AddToCart::orderBy('created_at', 'DESC')->get();

            return response()->json(['status' => 'success', 'data' => $data]);
        // } catch (\Throwable $th) {

        //     return response()->json(['status' => 'failed', 'msg' => "No Data Found!!"]);
        // }
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function addProduct(Request $request)
    {
        //validate incoming request 
        $validator = Validator::make($request->all(), [
            'product_id' => 'required|unique:add_to_carts',
            'quantity' => 'required|max:12',
            'user_id'=>'required'
        ]);

        if ($validator->fails()) {
            return response()->json(['status' => 'val_err', 'val_err' => $validator->errors()]);
        } else {
             $product = DB::table('products')->where('id',$request['product_id'])->exists();
             if($product) {
                   $Cart=DB::table('add_to_carts')->insert([
                        // 'user_id' => auth()->user()->id,
                        'product_id' => $request['product_id'],
                        'quantity' => $request->quantity
                    ]);
                     return response()->json(['code'=>200,'status'=>'success','message'=>'successfully added to cart']);
                    // try {
            //     $product = Product::find($request->product_id);
            //     if (!empty($product)) {
            //         AddToCart::create([
            //             // 'user_id' => auth()->user()->id,
            //             'product_id' => $request->product_id,
            //             'quantity' => $request->quantity
            //         ]);
            //     } else {
            //         return response()->json(['status' => 'success', 'msg' => "Product Not Available"]);
            //     }

            //     return response()->json(['status' => 'success', 'msg' => "Product Add in a cart Successfully!!"]);
            // } catch (\Throwable $th) {
            //     return response()->json(['status' => 'failed', 'msg' => "error adding"]);
            // }
        }
        else
        {
                   return response()->json(['status' => 'success', 'msg' => "Product Not Available"]);
        }
    }
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function viewCartById($id)
    {
        try {
            $data = AddToCart::findOrFail($id);
            return response()->json(['status' => 'success', 'data' => $data]);
        } catch (\Throwable $th) {
            return response()->json(['status' => 'failed', 'msg' => "No Data Found!!"]);
        }
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function updateCart(Request $request, $id)
    {
        $addToCart = AddToCart::findOrFail($id);
        //validate incoming request 
        $validator = Validator::make($request->all(), [
            'quantity' => 'required|max:10'
        ]);
        if ($validator->fails()) {
            return response()->json(['status' => 'val_err', 'val_err' => $validator->errors()]);
        } else {
            try {
                $addToCart->update([
                    'quantity' => $request->quantity,
                ]);
                return response()->json(['status' => 'success', 'msg' => "Cart Quantity updated Successfully!!"]);
            } catch (\Throwable $th) {
                return response()->json(['status' => 'failed', 'msg' => "error updating"]);
            }
        }
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function DeleteCart($id)
    {
        $addToCart = AddToCart::findOrFail($id);
        if ($addToCart->delete()) {
            return response()->json(['status' => 'success', 'msg' => "Cart Deleted Successfully!!"]);
        } else {
            return response()->json(['status' => 'failed', 'msg' => "No Data Found!!"]);
        }
    }
}
