<?php

namespace App\Http\Controllers;
use JWTAuth;
use Tymon\JWTAuth\Exceptions\JWTException;
use Illuminate\Http\Request;
use Symfony\Component\HttpFoundation\Response;
use Validator;
use App\Models\User;
use DB;
use Carbon\Carbon;
use Illuminate\Support\Facades\Auth;


class AuthController extends Controller
{
    // public $token=true;
     public function __construct() {
        $this->middleware('auth:api', ['except' => ['login', 'register']]);
    }
    public function viewUser()
    {
        $data = auth()->user();
        return response()->json(['status' => 'success', 'data' => $data]);
    }

    public function register(Request $request)
    {
        // // validate incoming request 
        $validator = Validator::make($request->all(), [
            'username' => 'required|unique:users|max:20',
            'email' => 'required|email|unique:users|max:50',
            'password' => ['required', 'min:3'],
            'phone' => 'required|numeric',
        ]);

        if ($validator->fails()) {
            return response()->json(['status' => 'val_err', 'val_err' => $validator->errors()]);
        } else {
        //     try {
                $plainPassword = $request->password;
                $password = app('hash')->make($plainPassword);

                $user=DB::table('users')->insert([
                     'username'=>$request->username,
                     'email'=>$request->email,
                     'password'=>$password,
                     'phone'=>$request->phone,
                     'created_at'=>Carbon::now()
                ]);
                return response()->json(['user' => $user, 'message' => 'User Created Succesfully'], 201);
            // } catch (\Exception $e) {
            //     return response()->json(['message' => 'User Registration Failed!'], 409);
            // }
        }
    }
    public function login(Request $request)
    {
        $validator = Validator::make($request->all(), [
            'email' => 'required|string|email',
            'password' => 'required|string',
        ]);

        if ($validator->fails()) {
            return response()->json(['status' => 'val_err', 'val_err' => $validator->errors()]);
        } else {
            $credentials = $request->only(['email', 'password']);
            if (!$token = auth()->attempt($credentials)) {
                return response()->json(['error' => 'Unauthorized!!'], 401);
            }
            return $this->respondWithToken($token);
        }
    }
    public function logout()
    {
        auth()->logout();
        return response()->json(['status' => 'success', 'message' => 'User has been logged out']);
    }
    public function refresh()
    {
        return $this->respondWithToken(auth()->refresh());
        // return "ok";
    }
    protected function respondWithToken($token)
    {
        return response()->json([
            'access Token'=>$token,
            'token_type'=>'bearer',
           'expires_in' => auth()->factory()->getTTL() * 60
        ]);
    }
}
