<?php

namespace App\Http\Controllers;

use App\Models\Category;
use Illuminate\Http\Request;
use Validator;

class CategoryController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
            // $data = Category::orderBy('created_at', 'desc')->get();
$data=Category::all();
            dd($data);
            return response()->json(['status' => 'success', 'data' => $data]);

            // return response()->json(['status' => 'failed', 'msg' => "No Data Found!!"]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request, Category $cat)
    {
        //validate incoming request 
        $validator = Validator::make($request->all(), [
            'name' => 'required|unique:categories|max:20'
        ]);

        if ($validator->fails()) {
            return response()->json(['status' => 'val_err', 'val_err' => $validator->errors()]);
        } else {
            try {
                $cat->create([
                    'name' => $request->name,
                    'desc' => $request->desc
                ]);
                return response()->json(['status' => 'success', 'msg' => $request->name . " Category Created Successfully!!"]);
            } catch (\Throwable $th) {
                return response()->json(['status' => 'failed', 'msg' => "error created Category"]);
            }
        }
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        try {
            $data = Category::findOrFail($id);
            return response()->json(['status' => 'success', 'data' => $data]);
        } catch (\Throwable $th) {
            return response()->json(['status' => 'failed', 'msg' => "No Data Found!!"]);
        }
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $cat = Category::findOrFail($id);
        if ($request->name) {
            $cat->name = 'null';
            $cat->save();
        }
        //validate incoming request 
        $validator = Validator::make($request->all(), [
            'name' => 'required|unique:categories|max:20'
        ]);

        if ($validator->fails()) {
            return response()->json(['status' => 'val_err', 'val_err' => $validator->errors()]);
        } else {
            try {
                $cat->update([
                    'name' => $request->name,
                    'desc' => $request->desc
                ]);
                return response()->json(['status' => 'success', 'msg' => $request->name . " Category updated Successfully!!"]);
            } catch (\Throwable $th) {
                return response()->json(['status' => 'failed', 'msg' => "error updated Category"]);
            }
        }
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function deleteCategory(Request $request)
    {
        $id=$request['id'];
        $cat = Category::where('id',$id)->get();
        if($cat)
        {
          $del = Category::where('id',$id)->delete();
          return response()->json(['status' => 'success', 'msg' =>" Category Deleted Successfully!!"]);        
        }
        else 
        {
            return response()->json(['status' => 'failed', 'msg' => "No Data Found!!"]);
        }
    }
}
