<?php

use Illuminate\Http\Request;
use App\Http\Controllers\AuthController;
use App\Http\Controllers\CategoryController;
use App\Http\Controllers\ProductController;
use App\Http\Controllers\ColdDrinksController;
use App\Http\Controllers\AddToCartController;
/*
|--------------------------------------------------------------------------
| API Routes
|--------------------------------------------------------------------------
|
| Here is where you can register API routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| is assigned the "api" middleware group. Enjoy building your API!
|
*/
Route::post('/register', 'AuthController@register');
Route::post('/login', 'AuthController@login');
Route::post('/logout', 'AuthController@logout');
Route::post('/refresh', 'AuthController@refresh');
Route::post('/view-user', 'AuthController@viewUser');

// category Routes
Route::get('/see-category', 'CategoryController@index');
Route::post('/add-category', 'CategoryController@store');
Route::get('/get-category/{id}', 'CategoryController@show');
Route::put('/update-category/{id}', 'CategoryController@update');
Route::post('/delete-category', 'CategoryController@deleteCategory');

// product Routes
Route::get('/get-product', 'ProductController@getProduct');
Route::post('/add-product', 'ProductController@addProduct');
Route::get('/view-product/{id}', 'ProductController@viewProduct');
Route::post('/edit-product/{id}', 'ProductController@productUpdate');
Route::post('/delete-product/{id}', 'ProductController@deleteProduct');

// Cold drink
Route::get('/view-drink', 'ColdDrinksController@viewDrink');
Route::post('/add-drink', 'ColdDrinksController@addDrink');
Route::get('/view-drinkbyid/{id}', 'ColdDrinksController@viewDrinkByID');
Route::post('/edit-drinkbyid/{id}', 'ColdDrinksController@updateDrink');
Route::post('/delete-drinkbyid/{id}', 'ColdDrinksController@deleteDrink');
// cart Routes
Route::get('/view-cart', 'AddToCartController@viewCart');
Route::post('/add-cart', 'AddToCartController@addProduct');
Route::get('/view-cartById/{id}', 'AddToCartController@viewCartById');
Route::put('/edit-cartById/{id}', 'AddToCartController@updateCart');
Route::post('/delete-cartById/{id}', 'AddToCartController@DeleteCart');



Route::middleware('auth:api')->get('/user', function (Request $request) {
    return $request->user();
});
